From a1bf21d22eaf8f7725c38703d29c748fc2161b33 Mon Sep 17 00:00:00 2001
From: mlimber <mlimber@gmail.com>
Date: Thu, 14 May 2020 13:09:05 -0400
Subject: [PATCH] PR symtab/25678: Set entry point when text segment is
 missing. From patch by Jeremie Courreges-Anglas.

---
 gdb/ChangeLog | 7 +++++++
 gdb/symfile.c | 7 ++++++-
 2 files changed, 13 insertions(+), 1 deletion(-)

diff --git a/gdb/ChangeLog b/gdb/ChangeLog
index c4da2a9..b25414f 100644
--- a/gdb/ChangeLog
+++ b/gdb/ChangeLog
@@ -1,3 +1,10 @@
+2020-05-14  M. Limber  <mlimber@gmail.com>
+
+	PR symtab/25678
+	* symfile.c: Set entry point when text segment is missing.
+	From patch by Jeremie Courreges-Anglas: 
+	https://marc.info/?l=openbsd-ports&m=146569238229407&w=2
+
 2020-05-14  Tankut Baris Aktemur  <tankut.baris.aktemur@intel.com>
 	    Tom de Vries  <tdevries@suse.de>
 	    Pedro Alves  <palves@redhat.com>
diff --git a/gdb/symfile.c b/gdb/symfile.c
index 7c862d5..e03c591 100644
--- a/gdb/symfile.c
+++ b/gdb/symfile.c
@@ -878,7 +878,12 @@ struct symfile_segment_data *
 	}
 
       if (!found)
-	ei->the_bfd_section_index = SECT_OFF_TEXT (objfile);
+	{
+	  if (objfile->sect_index_text == -1)
+	    ei->entry_point_p = 0;
+	  else
+	    ei->the_bfd_section_index = objfile->sect_index_text;	
+	}
     }
 }
 
-- 
1.9.1

